/*
	PROforma, PROgs FOnt & Raster MAnager

	Black drawing routines for mode 33 bitmap driver

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 9 November 1999
*/

#include "PFmodule.h"

Error BlackPixel(Bitmap bitmap, short x, short y)
{
	unsigned char *base=bitmap->base;	/* base of bitmap */

	/* clip pixel to useable area */
	if (x<0 || x>=bitmap->clip.xsiz ||
		y<0 || y>=bitmap->clip.ysiz)
		return ERR_OK;
	x+=bitmap->clip.xorg;			/* add origin in bitmap !! */
	y+=bitmap->clip.yorg;

	base+=y*bitmap->linc+x*2;		/* address in bitmap to set pixels */

	*((unsigned short *)base)=0;
	return ERR_OK;
}

Error BlackLineHorizontal(Bitmap bitmap, short y, short xs, short xe)
{
	unsigned char *base=bitmap->base;	/* base of bitmap */
	unsigned short *b;
	short dist; 					/* number of pixels to fill */

	/* clip line to useable area */
	if (xe<0 || xs>=bitmap->clip.xsiz ||
		 y<0 ||  y>=bitmap->clip.ysiz)
		return ERR_OK;
	if (xs<0) xs=0;
	if (xe>=bitmap->clip.xsiz) xe=bitmap->clip.xsiz;
	xs+=bitmap->clip.xorg;			/* add origin in bitmap !! */
	xe+=bitmap->clip.xorg;
	y +=bitmap->clip.yorg;
										
	dist=xe-xs;
	base+=y*bitmap->linc+xs*2;		/* address in bitmap to set pixels */
	b=(unsigned short *)base;
	for ( ; dist>=0 ; dist--) *b++=0;

	return ERR_OK;

}
