/*
	PROforma, PROGS Font & Raster Manager

	test program for v1.10

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 29 September 1995
*/

#include "sms.h"
#include "job.h"
#include "time.h"

#include "PROforma.h"

#define BOX 4
#define XORG (595-121*BOX)/2
#define YORG (842-121*BOX)/2
Bbox bbox={short2pt(121*BOX), short2pt(121*BOX),short2pt(XORG),short2pt(YORG)};

void drawbox(Gstate gstate, short x, short y)
{
	PFPathFilled(gstate);
	PFMoveTo(gstate,short2pt(XORG+x*BOX),short2pt(YORG+y*BOX));
	PFLineR(gstate,short2pt(BOX),0);
	PFLineR(gstate,0,short2pt(BOX));
	PFLineR(gstate,-short2pt(BOX),0);
	PFPathClose(gstate);
	PFPathDraw(gstate);
}

Error init()
{
	Gstate gstate;
	Error err;
	ColourCMYK colour;
	short c,m,y,k;

	LinkPROforma();
	err=PFGstateInit((int)"Epson Stylus Colour 180dpi",NULL,&bbox,&gstate,NULL);
	if (err) return err;

	for (c=0 ; c<=10 ; c++)
	for (m=0 ; m<=10 ; m++)
	for (y=0 ; y<=10 ; y++)
	for (k=0 ; k<=10 ; k++)
	{
		colour.cyan   =short2pt(c*10);
		colour.magenta=short2pt(m*10);
		colour.yellow =short2pt(y*10);
		colour.black  =short2pt(k*10);
		PFColourCMYK(gstate,&colour);
		drawbox(gstate,y*11+c,k*11+m);
	}

	return PFPageShow(gstate);
}
